//+------------------------------------------------------------------+
//|                                                        train.mqh |
//|                                 Copyright 2016, Yury V. Reshetov |
//|                                http://yury-reshetov.com/forum/55 |
//+------------------------------------------------------------------+
#property copyright "Copyright 2016, Yury V. Reshetov"
#property link      "http://yury-reshetov.com/forum/55"
/**
 * The quality of modeling in out of sample:
 *
 * TruePositives: 15
 * TrueNegatives: 5
 * FalsePositives: 4
 * FalseNegatives: 8
 * Total patterns in out of samples with statistics: 32
 * Total errors in out of sample: 12
 * Sensitivity of generalization abiliy: 78.94736842105263%
 * Specificity of generalization ability: 38.46153846153847%
 * Generalization ability: 17.40890688259109%
*/
double getBinaryClassificator1(double v0, double v1, double v2, double v3, double v4, double v5) {
   double x0 = 2.0 * (v0 + 2.128024) / 4.256231 - 1.0;
   double x1 = 2.0 * (v1 + 1.063966) / 10.641309000000001 - 1.0;
   double x2 = 2.0 * (v2 + 6.382972) / 9.573771 - 1.0;
   double x3 = 2.0 * (v3 - 0.0) / 2.296553 - 1.0;
   double x4 = 2.0 * (v4 + 36.086637) / 51.48082600000001 - 1.0;
   double x5 = 2.0 * (v5 + 19.890897) / 35.969434 - 1.0;
   double decision = 3.768315324347406 * x4
  + 1.0297117324520688 * x5
  + 0.3157699305632914 * sigmoid(x0)
  -1.084629856546978 * sigmoid(x0 + x4)
  -0.5027601401111482 * sigmoid(x1 + x2 + x4)
  -0.5489336947507829 * sigmoid(x0 + x4 + x5)
  -0.1307477132919931 * sigmoid(x0 + x1 + x4 + x5)
  -0.45484138477343333 * sigmoid(x3 + x4 + x5)
  -1.92394143056948 * sigmoid(x1 + x2 + x3 + x4 + x5)
  + 0.07613283329001275 * sigmoid(1.0 + x0 + x2)
  + 0.22023566398079042 * sigmoid(1.0 + x1 + x2)
  -1.084629856546978 * sigmoid(1.0 + x0 + x3 + x4)
  -0.5489336947507829 * sigmoid(1.0 + x0 + x3 + x4 + x5)
  -0.1307477132919931 * sigmoid(1.0 + x0 + x1 + x3 + x4 + x5);
   return decision;
}
double sigmoid(double x) {
   if (MathAbs(x) < 1.0) {
      return 2.0 * signum(x) - x;
   }
   return signum(x);
}
/**
 * The quality of modeling in out of sample:
 *
 * TruePositives: 19
 * TrueNegatives: 6
 * FalsePositives: 3
 * FalseNegatives: 4
 * Total patterns in out of samples with statistics: 32
 * Total errors in out of sample: 7
 * Sensitivity of generalization abiliy: 86.36363636363636%
 * Specificity of generalization ability: 60.0%
 * Generalization ability: 46.36363636363636%
*/
double getBinaryClassificator2(double v0, double v1, double v2, double v3, double v4, double v5) {
   double x0 = 2.0 * (v0 + 2.659514) / 9.043585 - 1.0;
   double x1 = 2.0 * (v1 + 6.382972) / 8.663305999999999 - 1.0;
   double x2 = 2.0 * (v2 + 2.127291) / 4.255223 - 1.0;
   double x3 = 2.0 * (v3 + 2.296553) / 4.593106 - 1.0;
   double x4 = 2.0 * (v4 + 7.08534) / 10.397173 - 1.0;
   double x5 = 2.0 * (v5 + 16.493085) / 33.548771 - 1.0;
   double decision = -0.9259938021116585 * x2
  -0.6368201550437489 * x4
  -0.03524526067494554 * sigmoid(x1 + x3)
  + 0.2403934339712503 * sigmoid(x0 + x2 + x3)
  + 0.4088514598504912 * sigmoid(x2 + x3 + x4)
  + 0.3621034204234258 * sigmoid(x0 + x1 + x2 + x3 + x4)
  -0.27059446309102786 * sigmoid(x0 + x3 + x5)
  -0.15386273897750932 * sigmoid(x1 + x3 + x5)
  + 0.025251728876174172 * sigmoid(x1 + x2 + x4 + x5)
  -0.014083623222451417 * sigmoid(1.0 + x0 + x1 + x2 + x3 + x4);
   return decision;
}
double signum(double x) {
  if (x == 0.0) {
    return 0.0;
  }
  if (x > 0.0) {
    return 1.0;
  }
  return -1.0;
}
/**
* Sensitivity of generalization abiliy: 82.92682926829268%
* Specificity of generalization ability: 47.82608695652174%
* Generalization ability: 70.3125%
* TruePositives: 34
* FalsePositives: 7
* TrueNegatives: 11
* FalseNegatives: 12
* Total patterns in out of samples with statistics: 64
*/
//Variable x0: W
//Variable x1: E
//Variable x2: R
//Variable x3: T
//Variable x4: Y
//Variable x5: X
int getTernaryClassificator(double x0, double x1, double x2, double x3, double x4, double x5) {
   double result1 = getBinaryClassificator1(x0, x1, x2, x3, x4, x5);
   double result2 = getBinaryClassificator2(x0, x1, x2, x3, x4, x5);
   if ((result1 * result2) > 0.0) {
      if (result1 > 0.0) {
         return(1);
      } else {
         return(0);
      }
   }
   return(-1);
}
